<?php
/*
 *Plugin Name: SmilePayB2C(PAY)
 *Description: SmilePay 7-11 b2c Shipping
 * Version: 4.0.0
 * Author:  SmilePay
 * Author URI: http://www.smilepay.net
*/
 
/**
 * Check if WooCommerce is active
 */

 /*if(!defined('SMILEPAY_B2CP_CHECK_CVS_STORE_SELECTED'))
    define('SMILEPAY_B2CP_CHECK_CVS_STORE_SELECTED',true);
*/
if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
    add_action('plugins_loaded', 'Smilepayb2cp_shipping_method_init', 0);
 
    add_action('woocommerce_checkout_update_order_review','Smilepayb2cp_shipping_method_match');
    add_action('woocommerce_checkout_init','Smilepayb2cp_shipping_method_match');//20200219ץhookJI
    add_action('before_woocommerce_pay','Smilepayb2cp_shipping_method_match_orderpay');

    //te覡LoIڤ覡
    function Smilepayb2cp_shipping_method_match()
    {
        if ( WC()->cart->needs_shipping() ) {
            global $smilepay_load_shipping_method;
            $packages = WC()->cart->get_shipping_packages();
            $payment_gateways = WC()->payment_gateways();
            $smilepay_b2cp_service_id = WC_Smilepayb2cp_Shipping_Method::getSupport_Service();
            if(!isset($smilepay_load_shipping_method) || $smilepay_load_shipping_method==false)
            {
                foreach ( $packages as $package_key => $package ) 
                {
                    WC()->shipping()->load_shipping_methods( $package );
           
                }
            }
            $shipping_methods =  WC()->shipping()->shipping_methods;
           



            foreach($shipping_methods as $shipping_method)
            {
               if( in_array($shipping_method->id,$smilepay_b2cp_service_id) && $shipping_method->get_instance_id() != 0)
               {
                   $smilepay_b2cp_shipping_method =  $shipping_method;
            
                   break;
               }
           
            }
            if( isset($smilepay_b2cp_shipping_method) &&  $smilepay_b2cp_shipping_method)
            {
                if($smilepay_b2cp_shipping_method->enabled!="yes")
                    return;
                if($smilepay_b2cp_shipping_method->instance_settings['payment_filter_enabled']!="yes")
                    return;
           
            }
        

            if(isset($_REQUEST['shipping_method'][0] ))
                $selected_shipping_method = $_REQUEST['shipping_method'][0] ;
            else
            {
                $chosen_methods = WC()->session->get( 'chosen_shipping_methods' );
                if(empty($chosen_methods))
                    return;
                $selected_shipping_method = $chosen_methods[0]; 
            }
                
            foreach ( $payment_gateways as $payment_gateway ) {
                 foreach ( $payment_gateway as $gateway ) {
                        if(in_array(strtolower($selected_shipping_method),$smilepay_b2cp_service_id))
                        {
                            if($gateway->id != 'smilepayb2c')
                                $gateway->enabled = 'no';
                        }
                        else
                        {
                            if($gateway->id == 'smilepayb2c')
                                $gateway->enabled = 'no';
                        }

                 }
            }
        }
         
      
    }
    //te覡LoIڤ覡 b
    function Smilepayb2cp_shipping_method_match_orderpay()
    {
        global $wp;

        if ( isset( $_GET['pay_for_order']) && $_GET['pay_for_order'] == 'true') 
        {
            $order_id = $wp->query_vars['order-pay'];
           
            if($order_id)
            {
                $smilepay_b2cp_service_id = WC_Smilepayb2cp_Shipping_Method::getSupport_Service();
                $order = wc_get_order( $order_id ); 
                if(!$order)
                    return;
                //$packages = WC()->cart->get_shipping_packages();
                
                //make fake package for find shipping region
                $packages = array();
                $packages[0]['destination']['country']   =  $order->get_shipping_country();
			    $packages[0]['destination']['state']     =  $order->get_shipping_state();
			    $packages[0]['destination']['postcode']  =  $order->get_shipping_postcode();
			    $packages[0]['destination']['city']      =  $order->get_shipping_city();
			    $packages[0]['destination']['address']   =  $order->get_shipping_address_1();
			    $packages[0]['destination']['address_2'] =  $order->get_shipping_address_2();

              
               
                //load shipping method
                foreach ( $packages as $package_key => $package ) 
                {
                     WC()->shipping()->load_shipping_methods( $package );
                }

              
                $shipping_methods =  WC()->shipping()->shipping_methods;
                $payment_gateways = WC()->payment_gateways();
                
                    
                foreach($shipping_methods as $shipping_method)
                {

                    if( in_array($shipping_method->id,$smilepay_b2cp_service_id)  && $shipping_method->get_instance_id() != 0)
                    {
                        $smilepay_b2cp_shipping_method =  $shipping_method;
                        break;
                    }
                }

                if( isset($smilepay_b2cp_shipping_method) &&  $smilepay_b2cp_shipping_method)
                {
                    if($smilepay_b2cp_shipping_method->enabled!="yes")
                        return;
                    if($smilepay_b2cp_shipping_method->instance_settings['payment_filter_enabled']!="yes")
                        return;
                }
         
               
                foreach($smilepay_b2cp_service_id as $service_id)
                {
                    $selected_shipping_method =    $order->has_shipping_method($service_id);
                    if( $selected_shipping_method)break;
                }
                
                foreach ( $payment_gateways as $payment_gateway ) {
                    foreach ( $payment_gateway as $gateway ) {
                        if($selected_shipping_method)
                        {
               
                            if($gateway->id != 'smilepayb2c')
                                $gateway->enabled = 'no';
                        }
                        else
                        {
                            if($gateway->id == 'smilepayb2c')
                                $gateway->enabled = 'no';
                        }   

                    }
                }


            }
            else
                return;



        }
    }


	function  Smilepayb2cp_shipping_method_init() {

        add_action('woocommerce_after_checkout_validation', 'WC_Smilepayb2cp_Shipping_Method::checkout_validate',10,2);
        add_action('woocommerce_after_shipping_rate','WC_Smilepayb2cp_Shipping_Method::shipping_emap_region');
        add_action( 'wc_ajax_smilepay_b2cp_save_emap', 'WC_Smilepayb2cp_Shipping_Method::ajax_save_emap' );
		if ( ! class_exists( 'WC_Smilepayb2cp_Shipping_Method' ) ) {
			class WC_Smilepayb2cp_Shipping_Method extends WC_Shipping_Method {

                const SMILEPAYB2CP_METHOD_ID_711 = 'smilepay_711_b2c_shippingpay';
                //const SMILEPAYB2CP_METHOD_ID_FAMI = 'smilepay_fami_b2c_shippingpay';
                protected static $installed_hook=FALSE;
                private static $support_service = array(
                                                   '711' => self::SMILEPAYB2CP_METHOD_ID_711,
                                                 //  'fami'=> self::SMILEPAYB2CP_METHOD_ID_FAMI
                                                );
                protected static $smilepay_payzg_sub_tb = array(
                                                        '711' => '7NET',
                                                      //  'fami' => 'FAMI'
                                                    );
                protected static $service_cvs_name = array(
                                                        '711' => '7-11',
                                                      //  'fami' => 'a'
                                                    );
                protected static $service_cvs_query_shipment_url = array(
                                                                        '711' => 'https://eservice.7-11.com.tw/E-Tracking/search.aspx',
                                                                  //      'fami' => 'https://www.famiport.com.tw/Web_Famiport/page/process.aspx'
                                                                     
                                                                    );
                private static $map_url = array(
                                                   '711' => array(
                                                                'mobile'=>'https://ssl.smse.com.tw/api/LogisticsEmap.asp?method=GET&TypesServer=711B2C&TypesInterface=MOBILE&tempvar=%s&url=%s',
                                                                'normal'=>'https://ssl.smse.com.tw/api/LogisticsEmap.asp?method=GET&TypesServer=711B2C&TypesInterface=WEB&tempvar=%s&url=%s'
                                                            ),
                                                   /*'fami'=>  array(
                                                                'mobile'=>'',
                                                                'normal'=>''
                                                            ),*/
                                                );
                private static $map_save_type = array(
                                                    self::SMILEPAYB2CP_METHOD_ID_711 =>'711',
                                                  //  self::SMILEPAYB2CP_METHOD_ID_FAMI =>'fami'
                                                );
				public function __construct($instance_id = 0) {
                    include_once("smilepayb2c.php");

                    $this->instance_id 			 = absint( $instance_id );
                    $smilepayb2cdata = new WC_SmilePayb2c();
                    
					$this->id                 = 'smilepay_711_b2c_shippingpay';
					$this->method_title       = __( 'SmilePay b2c 7-11 Shipping(PAY)' ); 
                    $this->method_description    = u2bbp('7-11WӨfI');

                    $this->service_id   = array(
                                            '711' => self::SMILEPAYB2CP_METHOD_ID_711,
                                            //'fami' => self::SMILEPAYB2CP_METHOD_ID_FAMI,
                                          );
                    //for woocommerce 2.6 modify
					//$this->enabled            = "yes";
                    $this->supports              = array(
			                                        'shipping-zones',
			                                        'instance-settings',
			                                        'instance-settings-modal',
		                                            );

                    if(isset($smilepayb2cdata->title) && !empty($smilepayb2cdata->title))
					    $this->title              = $smilepayb2cdata->title;//u2bbp("tRt7-11fI"); 
                    else
                        $this->title              = u2bbp("SmilePay 7-11WӨfI úO"); 
					$this->init();
            
				}

				public function init_form_fields() {  //x]m

					//for woocommerce 2.6 modify
					//$this->form_fields = array(
                    $this->instance_form_fields = array(
					/*	'enabled' => array(
							'title' => __(u2bbp("ҥ/"), 'woocommerce'),
							'type' => 'checkbox',
							'default' => 'yes',
                   			'label' =>  $this->title,
						),*/
						'fee' => array(
							'title'       => __(u2bbp('O'), 'woocommerce' ),
							'type'        => 'price',
							'description' => __( '', 'woocommerce' ),
							'default'     => '',
							'desc_tip'    => true,
							'placeholder' => wc_format_localized_price( 0 )
						),
						'fee_top' => array(
							'title'       => __(u2bbp('KBOe'), 'woocommerce' ),
							'type'        => 'price',
							'description' => __(u2bbp("F즹BɡAKBOAϥνЫOť"), 'woocommerce'),
							'desc_tip'    => true,
							'placeholder' => wc_format_localized_price( 0 )
						),
                        'min_total' => array(
							'title'       => u2bbp('̧COB'),
							'type'        => 'price',
							'description' => u2bbp('qBF즹]wBA~iHϥΦte覡AtBO'),
							'default'     => '',
						),			
                        'payment_filter_enabled' => array(
							'title' =>  u2bbp("SmilePay te覡ftIڤ覡Wh"),
                            'description' => __(u2bbp("}Ҧ\AbbɡAte覡OfIڡAIڤ覡ufIڡAYte覡OfIڡAhIڤ覡|X{fI"), 'woocommerce'),
							'type' => 'checkbox',
							'default' => 'yes',
                   			'label' => u2bbp("ҥ"),
						),		
                        'restric_categories' => array(
                                                'title'             => u2bbp('ӫ~O'),
				                                'type'              => 'multiselect',
				                                'class'             => 'wc-enhanced-select',
				                                'css'               => 'width: 400px;',
				                                'default'           => '',
				                                'description'       => u2bbp('Oӫ~iHϥΦte覡<br>hLctrlI<br>LctrlAIzwgQ<br>'),
				                                'options'           =>$this->get_all_categorys(),
				                                'custom_attributes' => array(
					                                'data-placeholder' => u2bbp('Oӫ~'),
				                            ),
                         ),			
						'hiddtext' => array(
							'title' => __(u2bbp('Wӯ¨f`Nƶ'), 'woocommerce'),
							'type' => 'hidden',
							'description' => __(u2bbp("ϥζWӯ¨f\Aݪ`NHUƶG
														<br><font color='red'>ҲնȤ䴩iSmilePay WӨfIڡjyҲաAнT{ҥ</font>							
														<br>1.ХSmilePayӮax}Ҩf\*<a target='_blank' href='http://www.smilepay.net/RVG.ASP'>Ӯax</a>*
														<br>2.bT<font color='red'>pq</font><font color='red'>X</font>Aӫ~ɷ|H²TqC
														<br>3.O̦߭qAiSmilePayӮaxo<font color='red'>fKNX</font>C
														<br>4.O̦߭qAiܭqƵI<font color='red'>}ҥfKAȳ</font>C														
														<br>5.бN<font color='red'>fKNX</font>ʷsWܰӫ~ƵAHQO̬dߪyAC
														<br>6.hаѾ\A<font color='red'>SmilePay</font>P<font color='red'>WooCommerceҲջ</font>C
														"), 'woocommerce'),
							'default' => __('', 'woocommerce')
						)         
					);
				}
 
				function init() {
					$this->init_form_fields(); 
					//$this->init_settings();
					$this->fee          = $this->get_option( 'fee' );
					$this->fee_top= $this->get_option( 'fee_top' );	
                    $this->min_total =$this->get_option('min_total');	
                    $this->payment_filter_enabled= $this->get_option( 'payment_filter_enabled' );									
					add_action( 'woocommerce_update_options_shipping_' . $this->id, array( $this, 'process_admin_options' ) );
                    $this->restric_categories = $this->get_option('restric_categories');

                    if($this->instance_id >0 &&  $this->enabled == 'yes' )
                    {
                         //add_action('woocommerce_after_checkout_validation', array( $this, 'checkout_validate' ),10,2);
                    }
                   
				}
                static function checkout_validate( $data, $errors )
                {
                   //$shipping_methods =$data['shipping_method'];
                   if ( WC()->cart->needs_shipping() ) {
                        $chosen_shipping_methods = WC()->session->get( 'chosen_shipping_methods' );
                        $chosen_payment_method = WC()->session->get( 'chosen_payment_method' ); 
                        $find_shipping_method=FALSE;
                        foreach($chosen_shipping_methods as $shipping_method)
                        {
                            if(self::isSupport_Service($shipping_method))
                            {
                                $find_shipping_method=TRUE;
                                if(defined("SMILEPAY_B2CP_CHECK_CVS_STORE_SELECTED") && SMILEPAY_B2CP_CHECK_CVS_STORE_SELECTED ==true)
                                {
                                    if(!self::checkout_is_selected_emap($shipping_method))
                                        $errors->add( 'shipping',u2bbp("fܡAХܨfA~򧹦bA¡C<br>"));
                                }
                            }
                        }
                        if( $find_shipping_method)
                        {
                        
                            $username=$data['billing_first_name'].$data['billing_last_name'];
                            if( !preg_match("/[^a-zA-Z0-9 ]/",$username))
                            {
                                $limit_name_number =10;
                            }
                            else
                            {
                                $limit_name_number =5;
                            }
				            if(substr($data['billing_phone'],0,2)!="09"||mb_strlen($data['billing_phone'])!=10||mb_strlen( $username, "utf-8")>$limit_name_number){
                               $errors->add( 'shipping',u2bbp("<br>qܮ榡~Ad09XX123456(@10X)C<br>O̩mWiWL5ӦrA­^hiWL10ӦrCЦAT{C<br>"));
                   
				            }
                            if(strtolower($chosen_payment_method) != 'smilepayb2c' )
                            {
                               $errors->add( 'shipping',u2bbp("<br>Iڤ覡ܿ~Ate覡iӥIڤ覡AЧ󴫨@<br>"));
                            }
                        }
                   }
                }
				/**
				 * calculate_shipping function.
				 *
				 * @access public
				 * @param mixed $package
				 * @return void
				 */
				public function calculate_shipping( $package = array() ) {
					$shipping_total=0;
					$shipping_total=$this->fee;
					
                    if($this->restric_categories)
                    {
                       //foreach ( $package as  $package_items ) 
                       if(isset($package['contents']))
                       {
                           foreach ( $package['contents'] as $package_item ) 
                           {
                               $product_categories =$package_item['data']->get_category_ids();
                               foreach($product_categories as $product_categories_id)
                               {
                                   if(in_array($product_categories_id,$this->restric_categories))
                                    return FALSE;
                               }
                           }
                       }              
                    }	


					$fee_top=$this->fee_top;
					$total = WC()->cart->cart_contents_total;					
					if($total>=$fee_top AND $fee_top<>0 AND $fee_top<>NULL)
					{$shipping_total=0;}
					
					$rate = array(
						'id' => $this->id,
						'label' => $this->title,
						'cost' => $shipping_total
					);
                    if($total < $this->min_total)
                        return;
					// Register the rate
					$this->add_rate( $rate );
				}
                // O_B2CPBe
                // $order_id:qs
                public function isSelectedSmilepayB2Cp($order_id)
                {
                 
                    if(!isset($order_id) || empty($order_id))
                    {
                        return false;
                    }
                    
                    $order = new WC_Order($order_id);
     
                    if(!isset($order) || empty($order))
                        return false;

                    if(is_admin())
                    {
                        $shipping_methods = $order->get_shipping_methods();
		                $has_method = false;
                             
         
		                if ( empty( $shipping_methods ) ) {
			                return false;
		                }
                         

		                foreach ( $shipping_methods as $shipping_method ) {

                            if ($shipping_method->get_method_id() == $this->id ) {
				                    return true;
			                }   
                            
			                
		                }
                        return FALSE;

                    }
                    else
                    {
                        foreach($this->service_id as $service_id) 
                        {
                           if( $order->has_shipping_method($service_id ))
                            return true; 
                        }
                        return false;
                    }
                   
                 }
                 public function get_all_categorys()
                 {
                     $args = array(
                               'hierarchical' => 1,
                               'show_option_none' => '',
                               'hide_empty' => 0,
                               'taxonomy' => 'product_cat'
                           );
                     $subcats = get_categories($args);
                     $ret_arr=array();
                     foreach ($subcats as $sc) {
                             $ret_arr[$sc->term_id] = $sc->name;
                     }
                     return $ret_arr;
                 }
                 public static function isSupport_Service($method_id)
                 {
                     if(in_array($method_id,self::$support_service))
                        return TRUE;
                     return FALSE;
                 } 
                 public static function getSupport_Service()
                 {
                     return self::$support_service;
                 }
                 public static function getCSVServiceArg($method_id)
                 {
                     foreach(self::$support_service as $key => $val)
                     {
                         if( $val == $method_id)
                            return self::$smilepay_payzg_sub_tb[$key];
                     }
                     return FALSE;
                 }

                 public static function getQueryShipmentUrl($method_id)
                 {
                     foreach(self::$support_service as $key => $val)
                     {
                         if( $val == $method_id)
                            return self::$service_cvs_query_shipment_url[$key];
                     }
                     return FALSE;
                 }

                 public static function getCSVServiceName($method_id)
                 {
                     foreach(self::$support_service as $key => $val)
                     {
                         if( $val == $method_id)
                            return  u2bbp(self::$service_cvs_name[$key]);
                     }
                     return FALSE;
                 }
                 //emap url
                 public static function getCSVMapUrl($method_id,$ret_url,$note='')
                 {
                     $useragent=$_SERVER['HTTP_USER_AGENT'];
                     foreach(self::$support_service as $key => $val)
                     {
                         if( $val == $method_id)
                         {
                            if(!isset(self::$map_url[$key]))
                                continue;
                            else
                            {
                                
                                if( preg_match('/Android|iPad|iPhone/i',$useragent)  )
                                {
                                    return sprintf(self::$map_url[$key]['mobile'],$note,urlencode($ret_url));
                                }
                                else
                                {
                                    return sprintf(self::$map_url[$key]['normal'],$note,urlencode($ret_url));
                                }
                            }
                         }
                           
                     }
                   
                     return '';
                     
                 }
                 //show emap
                static function shipping_emap_region($method)
                {
                    global $woocommerce;

                    $chosen_methods = WC()->session->get( 'chosen_shipping_methods' );
                    
                    if(!empty($chosen_methods) && $chosen_methods[0] == $method->id && self::isSupport_Service($method->id)) 
                    {

                        $ret_url =   get_site_url() ."/?wc-ajax=smilepay_b2cp_save_emap"."&type=".self::$map_save_type[$method->id ] ;
                        $emap_url=self::getCSVMapUrl( $method->id,$ret_url,'');
                        $store_data=self::checkout_load_storedata();

                        echo u2bbp("<button type='button' onclick='window.open(\"".$emap_url."\",\"_self\");'>f</button>");

                        if(self::checkout_is_selected_emap($method->id))
                        {
                            echo u2bbp('<div>fG<span style="color:blue;">').$store_data['storename'].'('.$store_data['storeid'].')<br>'.$store_data['storeaddress'] .'</span></div>';

                        }


                    }  
                }
                static function checkout_load_storedata()
                {
                    $store_data =array();
                    
                    $store_data['storeid']= WC()->session->get( 'smilepay_b2cp_storeid' );
                    $store_data['storename']= WC()->session->get('smilepay_b2cp_storename' );
                    $store_data['storeaddress']= WC()->session->get( 'smilepay_b2cp_storeaddress' );
                    $store_data['type'] = WC()->session->get( 'smilepay_b2cp_type' );
                    return $store_data;
                }
                static function checkout_clear_store_data()
                {
                    WC()->session->__unset( 'smilepay_b2cp_storeid' );
                    WC()->session->__unset( 'smilepay_b2cp_storename' );
                    WC()->session->__unset( 'smilepay_b2cp_storeaddress' );
                    WC()->session->__unset( 'smilepay_b2cp_type' );
                }
                static function checkout_is_selected_emap($method_id)
                {
                    $store_data= self::checkout_load_storedata();
                    
                    if(isset($store_data['type']) &&  isset(self::$support_service[$store_data['type']]) && $method_id == self::$support_service[$store_data['type']] )
                    {
                        if(!empty($store_data['storeid'])&& !empty($store_data['storename'])&& !empty($store_data['storeaddress']))
                            return true;
                    }
                    return false;
                }
                //save emap
                static function ajax_save_emap()
                {
                    global $woocommerce;
                    $checkout_url = wc_get_checkout_url();
                    $store_data=array();
                    if(isset($_REQUEST['storeid']))
                        $store_data['storeid']=$_REQUEST['storeid'];
                    if(isset($_REQUEST['storename']))
                        $store_data['storename']=$_REQUEST['storename'];
                    if(isset($_REQUEST['address']))
                        $store_data['storeaddress']=$_REQUEST['address'];
                    if(isset($_REQUEST['type']))
                        $store_data['type']=$_REQUEST['type'];
                    
                    self::checkout_save_storedata($store_data);
                    wp_redirect($checkout_url);
                    die();
                }
                static function checkout_save_storedata($store_data)
                {
                    if(isset($store_data['storeid']))
                         WC()->session->set( 'smilepay_b2cp_storeid',$store_data['storeid'] );
                    if(isset($store_data['storename']))
                         WC()->session->set( 'smilepay_b2cp_storename',$store_data['storename'] );
                    if(isset($store_data['storeaddress']))
                         WC()->session->set( 'smilepay_b2cp_storeaddress',$store_data['storeaddress'] );
                    if(isset($store_data['type']))
                         WC()->session->set( 'smilepay_b2cp_type',$store_data['type'] );

                }
                //hook sava order store data
                /*static function checkout_save_storedata_to_order($order_id, $posted_data, $order)
                {

                    if(empty($order))
                        $order = new WC_Order($order_id);

                    $shipping_method = @array_shift($order->get_shipping_methods());
                    $shipping_method_id = $shipping_method['method_id'];
                    if(self::isSupport_Service($shipping_method_id))
                    {
                        $store_data=self::checkout_load_storedata();
                        self::save_storedata_by_orderid($order_id,$store_data);
                        self::checkout_clear_store_data();
                        //$msg= 'G'.$store_data['storename'].'('.$store_data['storeid'].')<br>'."a}G".$store_data['storeaddress'];
                        //$order->add_order_note( $msg,"1");
                        $order->set_shipping_address_1($store_data['storeaddress']);
                        $order->save();
                    }
                    
                }*/

                function save_storedata_by_orderid($order_id=0,$store_data=array())
                {
                    self::_save_storedata_by_orderid($order_id,$store_data);
                }

                function load_storedata_by_orderid($order_id=0)
                {
                    return self::_load_storedata_by_orderid($order_id);
                }

                static function _save_storedata_by_orderid($order_id=0,$store_data=array())
                {
                    if(!empty($order_id))
                    {

                        if( isset($store_data['storeid'])&&isset($store_data['storename'])&&isset($store_data['storeaddress'])){
                            $data=$store_data['storeid'] .'/'.$store_data['storename'] .'/'.$store_data['storeaddress'];
                            update_post_meta( $order_id, 'smilepay_b2cp_storedata',$data );
                        }
                            
                    }
                }

                function _load_storedata_by_orderid($order_id=0)
                {
                    if(!empty($order_id))
                    {
                        $data=get_post_meta( $order_id, 'smilepay_b2cp_storedata',true);
                        $storedata_tmp=explode('/',$data);
                      
                        if(count($storedata_tmp)!=3)
                        {
                            $store_data['storeid']='';
                            $store_data['storename']=''; 
                            $store_data['storeaddress']='';
                        }
                        else
                        {
                            $store_data['storeid']=$storedata_tmp[0];
                            $store_data['storename']=$storedata_tmp[1]; 
                            $store_data['storeaddress']=$storedata_tmp[2];
                        }
                        
                        return $store_data;
                        
                    }
                    return NULL;
                }

                public static function get_order_smseid($order_id)
                {
                    return get_post_meta( $order_id, 'Smilepay_b2cp_SMSEID', true );
                }
                public static function set_order_smseid($order_id,$smseid)
                {
                    return update_post_meta( $order_id, 'Smilepay_b2cp_SMSEID', $smseid );
                }

                public static function get_order_tracknum($order_id)
                {
                    return get_post_meta( $order_id, 'Smilepay_b2cp_TRACKNUM', true );
                }
                public static function set_order_tracknum($order_id,$smseid)
                {
                    return update_post_meta( $order_id, 'Smilepay_b2cp_TRACKNUM', $smseid );
                }
			}
		}

	}
 
	add_action( 'woocommerce_shipping_init', 'Smilepayb2cp_shipping_method_init' );
    
 
	function add_Smilepayb2cp_shipping_method( $methods ) {
        //fill this->id for woocommerce2.6 modify
		//$methods[] = 'WC_Smilepayb2cp_Shipping_Method';
        $methods['smilepay_711_b2c_shippingpay'] = 'WC_Smilepayb2cp_Shipping_Method';
		return $methods;
	}
 
	add_filter( 'woocommerce_shipping_methods', 'add_Smilepayb2cp_shipping_method' );
}
function u2bbp($text)//eX
{	return iconv("big5","UTF-8",$text);}
function b2ubp($text)//gJƮw
{	return iconv("UTF-8","big5",$text);}
